<?php
class BootstrapAlert extends CWidget
{
    var $title = false;
    var $desc;
    var $level = 'warning';
    var $visible = null;
    var $dataBind = null;
  
    protected function registerClientScript()
    {                
    }
    public function init()
    {
        if ( $this->desc === null )
            ob_start();
    }
    public function run()
    {
        if ( $this->desc === null ) {
            $this->desc = ob_get_contents ( );
            ob_end_clean();
        }
        echo "\n";
        $options = array( 'class' => 'alert alert-'.$this->level.' alert-white rounded');
        if ( $this->visible ){
            if ( $this->dataBind )
                $this->dataBind .= ", visible: ".$this->visible;
            else
                $options['data-bind'] = "visible: ".$this->visible;
        }
        if ( $this->dataBind ){
            $options['data-bind'] = $this->dataBind;
        }
        
        echo CHtml::openTag( "div", $options );
        
        echo CHtml::tag("button" , array( 'class'=>'close', 'data-dismiss'=>'alert'), "&times;" );
        echo CHtml::tag("div" , array( 'class'=>'icon'), 
                CHtml::tag("i" , array( 'class'=>'fa fa-warning'), "" )
        );        
        if ( $this->title !== false ) {
            echo CHtml::tag("h4" , array(), $this->title );
            echo CHtml::tag("div", array(), $this->desc );
        } else {
            echo $this->desc;
        }
        
        echo CHtml::closeTag( "div" );
        echo "\n";
    }
}
