<?php
class SummaryBoxes extends CWidget
{
    var $content;
    var $link = false;
    var $genericLink = false;
    var $click = false;
    var $databind = false;
    var $name = false;
    var $title = false;
    var $labels = false;
    var $table = array();
    var $resourceModel = null;
    var $sizes = array( "col-md-5", "col-md-7" );
    var $data = null;
    
    protected function registerClientScript()
    {
        
        /*
        $cs=Yii::app()->clientScript;
        $cs->registerCssFile($cssFile);
        $cs->registerScriptFile($jsFile);         
         */
    }
    public function addData( $name, $value ){
        if ( $value === false )
            return "";
        return CHtml::tag("div", array( ), 
                CHtml::tag("div", array("class" => $this->sizes[0]), $name ).
                CHtml::tag("div", array("class" => $this->sizes[1]), $value )
        ) . "\n";
    }
    public function table( $labels, $table, $options = array() ){
        $result = "";
        
        $result .= CHtml::openTag("table", array( "class" => "no-border" ) ) ."\n";
        if ( $labels ) {
            $result .= CHtml::openTag("thead", array( "class" => "no-border" ) );
            $result .= CHtml::openTag("tr" ) ."\n";            
            foreach( $labels as $idx => $label ){            
                $result .= CHtml::tag("th ", array( "class" => $this->sizes[$idx] ), $label );
            }
            $result .= CHtml::closeTag("tr" ) ."\n";
            $result .= CHtml::closeTag("thead" ) ."\n";
        }
        if ( isset( $options['class'] ) )
            $options['class'] .= " no-border-y";
        else
            $options['class'] = "no-border-y";
        $result .= CHtml::openTag("tbody", $options );            
        foreach( $table as $row ){
            $result .= CHtml::openTag("tr" ) ."\n";
            foreach( $row as $idx => $cell ){                
                $result .= CHtml::tag("td", array( "class" => $this->sizes[$idx] ), $cell );                
            }
            $result .= CHtml::closeTag("tr" ) ."\n";
        }
        $result .= CHtml::closeTag("tbody" ) ."\n";
        $result .= CHtml::closeTag("table" ) ."\n";
        return $result;
    }
    public function addLabels( $name1, $name2 ){
        $this->labels[] = array( $name1, $name2 );        
    }
    public function addRow( $name, $value ){
        $this->table[] = array( $name, $value );        
    }
    public function init()
    {
        ob_start();
    }
    public function run()
    {
        $this->content = ob_get_contents ( );
        ob_end_clean();
        if ( count( $this->table ) >0 ) {
            $this->content = $this->table( $this->labels, $this->table ) . $this->content;
        }
        $this->render( 'summaryBoxes' );
    }
}
