<?php
class WebUser extends CWebUser {
	public $status;
    public $info;
    
    protected $_apikey = false;
    protected $autentication_path = "";
    
    public $ikebanaBetaFeatureRemove = true;
    
    public function getApikey() {
        if ( $this->_apikey === false ){
            $this->_apikey = Yii::app()->request->getParam('apikey',null);
        }
        return $this->_apikey;           
    }
    public function clearApikey(){
        $this->_apikey = null;
    }
	public function init() {
        
        $apikey = $this->getApikey();
        if ( $apikey ) {
            $identity = UserIdentity::newFromAPIKey( $apikey );            
            if ( !$identity->errorCode ) {
                $this->setStateKeyPrefix( "apikey" );
                $this->login( $identity );
            } else {
                $this->clearApiKey();
                parent::init(); 
            }
        } else {
            parent::init(); 
        }
        
        $wizard = new Wizard();
        if( $wizard->getWelcome() ){
            // auto log the user
            $identity=new UserIdentity('admin', 'admin');
            $identity->authenticate();
            if ( $identity->errorCode === UserIdentity::ERROR_NONE ){
                $this->login($identity );
                $this->setState('autolog', true);
            }
        }
        
        $this->info = new SerialNumber;
        $this->status = new Status;
        
        openlog("spxmanage.yii", LOG_ODELAY|LOG_PID, LOG_USER);        
	}
    public function checkAccess($operation, $params=array ( ), $allowCaching=true ){
        Yii::log("checkAccess($operation, ".(count($params)>0?print_r($params,true):"()").", ".($allowCaching?"true":"false"). ")", 'debug', 'spx.user');
        if ( strpos($operation, "External" ) && !Yii::app()->branding->hasRight('contentLiveSource') ){
            return false;           
        }
        return parent::checkAccess($operation, $params, $allowCaching);
    }
    public function loginRequired()
	{
        $app=Yii::app();
        // need to destroy the session automatically created by yii, otherwise we may create a session as root.
        $app->getSession()->destroy();
        
		$request=$app->getRequest();
 
		if( $request->getIsAjaxRequest() )
		{			
            http_response_code( 403 );
            
			header('Content-type: application/json');
            header('Access-Control-Allow-Origin: *');
            header('Access-Control-Allow-Methods: POST, GET, PUT, DELETE');

            header('Cache-Control: no-cache');
            header('Pragma: no-cache');	
		}

		parent::loginRequired();
	}
    public function afterLogin( $fromCookie ){      
        
        // touch only on regular log-in
        if ( !$fromCookie && !$this->getApiKey() ){
            $authentication_path = ini_get( 'session.save_path' );
            $id = yii::app()->getSession()->getSessionID();        
            touch( $authentication_path ."/auth_".$id );     
            if ( $this->checkAccess('monitoring') ){
                touch( $authentication_path ."/auth_monitoring_".$id );     
            }
            if ( $this->checkAccess('content') ){
                touch( $authentication_path ."/auth_content_".$id );     
            }
            if ( $this->checkAccess('admin') ){
                touch( $authentication_path ."/auth_admin_".$id );     
            }
        }
    }
    public function beforeLogout( ){
        $id = yii::app()->getSession()->getSessionID();
        $authentication_path = ini_get( 'session.save_path' );
        if (file_exists( $authentication_path ."/auth_".$id ) ){
            unlink( $authentication_path ."/auth_".$id );
        }
        if (file_exists( $authentication_path ."/auth_monitoring_".$id ) ){
            unlink( $authentication_path ."/auth_monitoring_".$id );
        }
        if (file_exists( $authentication_path ."/auth_content_".$id ) ){
            unlink( $authentication_path ."/auth_content_".$id );
        }
        if (file_exists( $authentication_path ."/auth_admin_".$id ) ){
            unlink( $authentication_path ."/auth_admin_".$id );
        }
        return true;
    }
}
