<?php

yii::import('application.modules.controlcenter.controllers.actions.SystemAction');
yii::import('application.modules.controlcenter.controllers.actions.DisplayAction');
yii::import('application.modules.api.controllers.ApiController');
class MainController extends Controller
{
    public $defaultAction = 'index';
    public function accessRules()
    {
        $rules = array(
            array('allow',
                'actions' => array( 'firmware' ),
                'expression'=> "Updater::isUpdateInProgress()",
            )
        );        
        return array_merge( $rules, parent::accessRules() ); ;
    }
    public function actionIndex()
	{        
        $screenInfo = new ScreenInfo;
        $screenInfo->load();
        $playerConfig = new PlayerConfig;
        
		$options = array(   
            'screenInfo' => $screenInfo,
            'playerConfig' => $playerConfig
        );        
		$this->render('index', $options);        
	}
    
	public function actionList()
	{
		$this->render('list');
	}

	public function actionApps()
	{
		$this->render('apps');
	}    
    public function actionFirmware( $source = 'base' )
	{    
        $this->render('firmware', array( 
            'source' => $source
        ));
	}
    public function actionCheckAlive()
	{
		if ( !Yii::app()->request->isAjaxRequest )
			throw new CHttpException(403 , "Direct access not allowed");
		
		echo json_encode( array( 
            'success' => true,
            'boot-id' => Tools::getBootID()
        ) );
	}
}