<?php


class ActionSet extends CWidget
{
    var $actions = array();
    var $style = 'auto'; // one fo the following 'text', 'icon', 'all', 'auto'
    var $size = false;
    var $options = array();
    var $presets = array(
        'save' => array( 'icon'=> 'save', 'title' => 'Save', 'type' => 'primary' ),
        'apply' => array( 'icon'=> 'save', 'title' => 'Save', 'type' => 'primary' ),
        'ok' => array( 'icon'=> 'check', 'title' => 'OK' ),
        'new' => array( 'icon'=> 'plus', 'title' => 'New Playout' ),
        'upload' => array( 'icon'=> 'download', 'title' => 'Upload Media', "class" => "fileinput-button" ),
        'backup' => array( 'icon'=> 'upload', 'title' => 'Backup' ),
        'properties'=> array( 'icon'=>'gear', 'title' => 'Setup'),   
        'calendar'=> array( 'icon'=>'calendar', 'title' => 'Calendar'),
        'large'=> array( 'icon'=>'stop', 'title' => 'Large'),  
        'medium'=> array( 'icon'=>'th-large', 'title' => 'Medium'),  
        'small'=> array( 'icon'=>'th', 'title' => 'Small'),  
        'list'=> array( 'icon'=>'list', 'title' => 'List View'),  
        'edit'=> array( 'icon'=>'pencil', 'title' => 'Edit'),  
        'remove'=> array( 'icon'=>'times', 'title' => 'Remove'),
        'clear'=> array( 'icon'=>'times', 'title' => 'Clear'),
        'horizontal' => array( 'icon'=> 'stop stretch-h', 'title' => 'Horizontal'),
        'vertical' => array( 'icon'=> 'stop stretch-v', 'title' => 'Vertical'),
        'copy' => array( 'icon'=> 'copy', 'title' => 'Copy'),
        'selectall' => array( 'icon'=> 'check', 'title' => 'Select All')
    );
    public function addOptions( &$options, $newOptions ){
        foreach( $newOptions as $name => $value ){
            $sep = "; ";
            switch ( $name ){
                case 'class': $sep = " "; break;
                case 'data-bind': $sep = ", "; break;
            }
            if ( isset( $options[$name]) )
                $options[$name] .= $sep.$value;
            else
                $options[$name] = $value;
        }
    }
    public function addClass( &$options, $class ){
        $this->addOptions( $options, array( 'class' => $class) );
        
    }
    
    function button( $action ){
        if ( isset($action['preset']) ){
            if ( isset( $this->presets[ $action['preset'] ]) ){
                $action = array_merge($this->presets[ $action['preset'] ], $action);                
            }
            unset($action['preset'] );
        }
        if ( isset($action['html']) ){
            $html = $action['html'];
            unset($action['html']);
        } else {
            $html = "";
        }
        if ( isset($action['icon']) ) {
            if ( $this->style === 'icon' || $this->style === 'all' || $this->style === 'auto') {
                $class =  "fa fa-fw fa-".$action['icon'];
                if ( $this->style === 'auto' ){
                    $html .= CHtml::tag("span", array( "class" => "visible-xs-inline visible-sm-inline" ) , CHtml::tag("i", array( "class" =>$class ), "" ) );
                } else {
                    $html .= CHtml::tag("i", array( "class" =>$class ), "" );
                }
                
            }
            unset($action['icon']);
        }
        if ( $this->style === 'text' || $this->style === 'all' || $this->style === 'auto' ){
            if ( isset($action['title']) ){
                $class = "";
                if ( $this->style === 'auto' ){
                    $class .= "hidden-xs hidden-sm";
                }
                $html .= CHtml::tag("span", array( "class" =>$class ), $action['title'] );              
            }
        }
        
        $class = "btn";
        if ( $this->size ){
            $class .= " " . $this->size;
        }
        if ( isset($action['type']) ){
            $class .= " btn-".$action['type'];
            unset($action['type']);
        } else {
            $class .= " btn-default";
        }
        
        $options = $action;
        $this->addClass( $options, $class );        
        
        return CHtml::tag("span", $options, $html );
    }

    
    public function init()
    {
        //ob_start();
    }
    public function run()
    {
        $this->addClass( $this->options, "btn-group" );  
        echo CHtml::openTag("span", $this->options );
        foreach ( $this->actions as $action ){  
            if ( !isset( $action['visible']) || $action['visible'] ){
                echo $this->button( $action );
            }
        }
        echo CHtml::closeTag("span" ); 
    }
}
