<?php
/* @var $this PlaylistEdit */
// If neededing additonal scripts
//Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl.'/js/ascript/file',CClientScript::POS_END);

$agent = Yii::app()->request->userAgent;
if ( strpos($agent, 'iPhone OS 7') === false && strpos($agent, 'iPad OS 7') === false ){
    $multiple = 'multiple="multiple" ';
} else {
    $multiple = "";
}

$this->controller->topBar .= $this->widget('ActionSet', array(
    'actions' => array(
        array( 'preset'=> 'ok',
                'data-bind' => 'click: save, visible: playlist().inline()'),
        array( 'preset'=> 'copy',
                'data-bind' => 'click: copy, visible: !playlist().inline() && id()',
                'visible' => Yii::app()->user->checkAccess('copyPlaylist')
        ),
        array( 'preset'=> 'apply',
                'data-bind' => 'click: apply, hidden: playlist().inline() || !status.isDirty()')
    ),
    'options' => array( 
        "class" => "pull-right", 
        "data-bind" => 'if: playlist(), visible: playlist() && playlist().visible()'
    )
), true);

$this->controller->topBar .= $this->widget('ActionSet', array(
    'actions' => array(
        array( 'preset'=> 'properties',                 
                'data-bind' => 'click: function(){ playlist().editProperties( !playlist().editProperties() ); }, '.
                                'css: { active: playlist().editProperties()}, ',
                'id' => 'EditPlaylistProperties')
    ),
    'options' => array( 
        "class" => "pull-right", 
        "data-bind" => 'if: playlist(), visible: playlist() && playlist().visible()'
    )
), true); 

$this->controller->topBar .= $this->widget('ActionSet', array(
    'actions' => array(
        array( 'preset'=> 'upload',
                'html' => '<input type="file" '.$multiple.'name="media" data-bind="jQueryFileupload: addMediaFile, args: {url: spxapi.media.uri} " />' ),        
    ),
    'options' => array( 
        "class" => "pull-right", 
        "data-bind" => 'if: playlist(), visible: playlist() && playlist().visible()'
    )
), true); 

$this->controller->topBar .= $this->controller->helpButton( 
    array(
        'steps' => array(
            array( 'intro' => 'This page let you edit Playlist'),
            array( 
                'element' => '#MediaIconViewTable',
                'intro' => 'Select the assets to be added to the playlist',
                "position" => 'top'
            ),
            array( 
                'element' => '#playlistEditZone',
                'intro' => 'Drop the assets to add it to the playlist.',
                "position" => 'bottom'
            ),
            array( 
                'element' => '#playlistEditZone',
                'intro' => 'Directly upload media using drag &amp; drop from explorer',
                "position" => 'bottom'
            ),
            array( 
                'element' => '#EditPlaylistProperties',
                'intro' => 'Click to setup the playlist configuration, such as the default duration.',
                "position" => 'left'
            ),
        )
    ), "startIntroPlaylist", array( 
        "data-bind" => 'if: playlist(), visible: playlist() && playlist().visible()'
    )
);


?>
<div id='playlistEditZone' class="spx-dropzone" data-bind="hidden: !playlist() || !playlist().visible() ">
    <div class="row clearfix spx-row-border" data-bind="with: playlist" >
        <div data-bind="css: { 'col-sm-12': !editProperties(), 'hidden-xs': editProperties(), 
                               'col-sm-6': editProperties(), 'col-md-8': editProperties() }">
            <div class="clearfix spx-top-view spx-gallery row" 
                 data-bind="sortable: { data: media, dragged: createPlaylistItem, options: { items: '.can-sort'} }" 
                 <?php echo 'id="' . $this->id . '"'; ?> 
                 >                
                <div data-bind="css: { 'col-md-2': !$parent.editProperties(),'col-sm-3': !$parent.editProperties(),'col-xs-6': !$parent.editProperties(), 
                                       'col-md-3':  $parent.editProperties(), 'col-sm-6':  $parent.editProperties(), 
                                       'can-sort': !placeholder }">
                    <div class="block-flat widget-block spx-media-block">
                        <!-- ko ifnot: placeholder -->
                        <div class="header">
                            <span class="pull-right btn-group">
                                <a class='btn btn-default btn-xs' data-bind='click: $parent.remove'><i class='fa fa-times'></i></a>                                
                                <a class='btn btn-default btn-xs' tabindex="0" data-bind="popover: { 
                                    template: 'popoverBindingTemplate', 
                                    title: name.shortStr, 
                                    placement: $parent.popupPlacement
                                }"><i class='fa fa-gear'></i></a>                               
                            </span>  
                            <h4 data-bind="text: $index()+1">x</h4>
                            <div>
                                <span data-bind="visible: schedule.beginDate() || schedule.endDate()">
                                <i  class="fa fa-calendar-o"></i> &nbsp;
                                </span>
                                <span data-bind="text: displayDur.formated, css: { 'text-muted' : !dur() }"> </span>                                
                            </div>
                        </div>
                        <div class="content">
                            
                            <div class="spx-preview-fixed">                                
                                <div class="spx-preview spx-preview-fixed-item spx-preview-background" data-bind="style: { backgroundImage: 'url('+preview()+')'}">
                                    <span class="spx-media-info playlist" data-bind="html: typeIcon"></span>
                                </div>
                            </div>                             
                        </div>
                        <!-- /ko -->
                        <!-- ko if: placeholder -->  
                        <div class="header">
                            <h4 style='color: #999;' data-bind="text: $index()+1">x</h4>
                            <div>                                
                                <span >&nbsp;</span>
                            </div>
                        </div>
                        <div class="content">
                            <div class="spx-preview-fixed">
                                <div class="spx-preview empthy spx-preview-fixed-item">
                                <div ><div >
                                    Drag &amp; drop<br/>
                                    <span data-bind="hidden: $parent.inline()" class="fa-stack"><i class="fa fa-circle fa-stack-2x"></i><i class="fa fa-inverse fa-desktop fa-stack-1x"></i></span>
                                    <span class="fa-stack"><i class="fa fa-circle fa-stack-2x"></i><i class="fa fa-inverse fa-picture-o fa-stack-1x"></i></span>
                                    <span class="fa-stack"><i class="fa fa-circle fa-stack-2x"></i><i class="fa fa-inverse fa-video-camera fa-stack-1x"></i></span>                                                                                
                                </div></div> 
                                </div>                       
                            </div>
                        </div>
                        <!-- /ko -->
                    </div>                
                </div>    
            </div>              
        </div>
        <div data-bind="if: editProperties" class="col-xs-12 col-sm-6 col-md-4">
            <div class="panel panel-info" >
                <div class="panel-heading" data-bind="text: name">Properties</div>
                <div class="panel-body">
<?php 
$this->widget('PropertiesInput', array(
    'src' => 'properties'
)); 
?>  
                </div>
            </div>            
        </div>
    </div> 
</div>
<script type="text/html" id="popoverBindingTemplate">
    <div class="spx-popover">
<?php 
$this->widget('PropertiesInput', array(
    'src' => 'properties'
)); 
?> 
    </div>
</script>


