<?php

yii::import('application.modules.controlcenter.controllers.actions.SystemAction');
yii::import('application.modules.controlcenter.controllers.actions.DisplayAction');

class MainController extends ControlCenterController
{
    public $defaultAction = 'summary';
    public function accessRules()
    {
        $rules = array(
            array('allow',
                'actions' => array( 'advanced' ),
                'roles'=>array('useAdvancedConfig'),
            ),
            array('allow',
                'actions' => array( 'index', 'summary', 'logs' ),
                'roles'=>array('viewLogs'),
            ),
            array('deny',
                'actions' => array( 'advanced' ),
                'users'=>array('*')
            ),
        );
        
        return array_merge( $rules, parent::accessRules() ); ;
    }
    public function actions()
    {
        $base = 'application.modules.controlcenter.controllers.actions.';
        return array(
            'index'=> $base.'SummaryAction',
            'summary'=> $base.'SummaryAction',
            'system'=> $base.'SystemAction',
            'display'=> $base.'DisplayAction',
            'network'=> $base.'NetworkAction',
            'content'=> $base.'ContentAction',
            'applications'=> $base.'ApplicationsAction',
            'peripherals'=> $base.'PeripheralsAction',
            'operations'=> $base.'OperationsAction',
            'logs'=> $base.'LogsAction',
            'advanced'=> $base.'AdvancedAction',
        );
    }
    
    public function actionPullmodeScheduleGet()
	{
        $pullModeConfig = new PullModeConfig;
        $pullModeConfig->download();                
    }
    public function actionPullmodeScheduleSet()
	{
        $this->ajaxOnly(); 
        $errors = array();
        
        $pullModeConfig = new PullModeConfig;
        $pullModeConfig->load();
        $pullModeConfig->setSelectMode( PullModeConfig::PULL_FILE );        
        $pullModeConfig->setAttributes( $_POST['PullModeConfig'] );
        if ( $pullModeConfig->validate() ){
            $pullModeConfig->save();
            Tools::addMessage('Schedule file uploaded');
        }
        
        $this->render('/layouts/ajax', array(
            'errors' => $this->updateErrors( $pullModeConfig, $errors )
        ));
    }
    public function actionAbout()
	{
        $this->render( 'about' );
    }    
    
}