<?php
class AdvancedAction extends CAction
{
    static function log( $simpleFormId )
	{
        $logConfig = new LogConfig;    
        $logConfig->load();
        
        $ok = null;
        if ( isset($_POST['LogConfig']) ) {			
            $ok = true;
            $logConfig->setAttributes( $_POST['LogConfig'] );
            if ( !$logConfig->validate() )
                $ok = false;
        }
        if ( isset($_POST['AppenderConfig']) && $simpleFormId == "Appender" ) {
            if ( $ok == null){
                $ok = true;
            }
            $logConfig->appenders = array();
            foreach ( $_POST['AppenderConfig'] as $appenderConfigData) {
                if ( !is_array($appenderConfigData) ) {
                    continue;
                }
                $appenderConfig =  new AppenderConfig;
                $appenderConfig->setAttributes( $appenderConfigData );
                if ( !$appenderConfig->validate() ){
                    $ok = false;
                }
                $logConfig->appenders[$appenderConfig->name] = $appenderConfig;
                    
            }
        }
        if ( isset($_POST['LoggerConfig']) ) {
            if ( $ok == null){
                $ok = true;
            }
            foreach ( $_POST['LoggerConfig'] as $logData ) {
                $loggerConfig = new LoggerConfig;
                if (!isset($logData['name']) || $logData['name']=="" ) {
                    continue;
                }
                $loggerConfig->name = $logData['name'];
                $loggerConfig->priority = $logData['priority'];
                $refs = array();
                foreach ( $logData as $name=>$val ) {
                    if ( $name != 'name' && $name != 'priority' ) {
                        $refs[$name]=$val;
                    }
                }
                $loggerConfig->refs = $refs;
                $logConfig->loggers[$loggerConfig->name] = $loggerConfig;
            }
        }
        $appenderConfig =  new AppenderConfig;
        if ( isset($_POST['AppenderConfig']) && $simpleFormId == "NewAppender" ) {
            if ( $ok == null){
                $ok = true;
            }
            $appenderConfig->setAttributes( $_POST['AppenderConfig'] );
            if ( $appenderConfig->validate() ) {
                $logConfig->appenders[$appenderConfig->name] = $appenderConfig;
                $appenderConfig =  new AppenderConfig;                
            } else {
                $ok = false;
            }
        }
        
        if ( $ok ){
            //throw new Exception(print_r($logConfig, true));
            $logConfig->save();
        }
        $logConfig->load();
    
        
        
        return array( 
            'logConfig' => $logConfig,
            'appenderConfig' => $appenderConfig
        );
	}
    static function player()
	{
        $playerConfig = new PlayerConfig;
        
        if( isset($_POST['PlayerConfig']) ) {
            $playerConfig->setScenario( 'player'  );
            $playerConfig->setAttributes( $_POST['PlayerConfig'] );
            
            if ( $playerConfig->validate()  ) {
                $playerConfig->saveConfig();
            }
        }  
            
        $playerConfig->loadAdvValues();
        return array(
            'playerConfig' => $playerConfig
        ); 
    }
    public function run()
    {
        $simpleFormId = isset($_POST['SimpleFormId'])?$_POST['SimpleFormId']:"";
        $options = array( );
        $options += self::log( $simpleFormId );
		$options += self::player();
        $this->controller->render( 'advanced', $options );
    }
}