<?php
class NetworkAction extends CAction
{
    
    protected function network( ) {

		$ipConfig = new IPConfig;
        
        $modem3g = new Modem3G;
        $modem3g->load();
        if ( isset($_POST['IPConfig']) ){
            if ( isset($_POST['IPConfig']['dhcp']) ) {
                if ( $_POST['IPConfig']['dhcp'] )
                    $ipConfig->setScenario( 'dhcp'  );
                else
                    $ipConfig->setScenario( 'fixip'  );
                $ipConfig->setAttributes( $_POST['IPConfig'] );
                if ( $ipConfig->validate() && $ipConfig->checkConfig(  ) )
                    $ipConfig->save();                
            } else
                $ipConfig->load();
            if ( isset($_POST['Modem3G']) ) {
                $ipConfig->setScenario( 'modem3g'  );
                $configSave = false;
                $configOk = true;
                if ( $ipConfig->changedInterface($_POST['IPConfig']) ) {
                    $ipConfig->setAttributes( $_POST['IPConfig'] );
                    $configSave = true;
                    $configOk = $ipConfig->validate();                        
                }

                $modem3g->setAttributes( $_POST['Modem3G'] );
                if ( $modem3g->isPINBlocked() ) {
                    $modem3g->resetPIN();
                }
                if ( $modem3g->validate() && $configOk ) {
                    if ( $configSave )
                        $ipConfig->save();
                    $modem3g->save();
                }
            } 
        } else
            $ipConfig->load();
		return array( 
            'ipConfig' => $ipConfig,
            'modem3g' => $modem3g
        );
	}
    protected function proxy()
	{
        $proxyConfig = new ProxyConfig;
        $proxyConfig->load();
        if ( isset($_POST['ProxyConfig']) ) {
            $proxyConfig->setAttributes( $_POST['ProxyConfig'] );            
            if ( $proxyConfig->validate() )
                $proxyConfig->save();            
        }        
		return array( 
            'proxyConfig' => $proxyConfig 
        );
	}
    protected function https($playerConfig = null, $simpleFormId = "HTTPS" ) {
        if ( !$playerConfig ){
            $playerConfig = new PlayerConfig;
        }	
        
        if ( $simpleFormId == "HTTPS" && isset($_POST['PlayerConfig']) ) {
            $playerConfig->setScenario( 'https'  );
            
            $playerConfig->setAttributes( $_POST['PlayerConfig'] );
            if ( $playerConfig->validate()  ) {
                $playerConfig->saveConfig();
            }
        }
        
		return array( 
            'playerConfig' => $playerConfig
        );
        
	}
    protected function ssl()
	{		
        $sslConfig = new SSLConfig;
        
		return array( 
            'sslConfig' => $sslConfig,
        );
	}
    
    protected function watchdog()
	{
        if ( !Yii::app()->branding->hasRight('networkWatchdog') ){
            return array();
        }
        $watchdog = new NetworkWatchdog;
        if ( isset( $_POST['NetworkWatchdog'] ) ) {
            $watchdog->setAttributes( $_POST['NetworkWatchdog'] );
            if ( $watchdog->validate() )
                $watchdog->save();
        } else {
            $watchdog->load();
        }
		return array( 'watchdog' => $watchdog );
	}
    
    protected function snmp()
	{		
        if ( !Yii::app()->branding->hasRight('networkSNMP') ){
            return array();
        }
        $snmpConfig = new SNMPConfig;
        if ( isset($_POST['SNMPConfig']) ) {
            $snmpConfig->access = $_POST['SNMPConfig']['access'];
            $snmpConfig->setScenario( $snmpConfig->access );
            $snmpConfig->setAttributes( $_POST['SNMPConfig'] );
            if ( $snmpConfig->validate() )
                $snmpConfig->save();            
        } 
        $snmpConfig->load();
        
		return array( 
            'snmpConfig' => $snmpConfig
        );
	}
    
    public function run()
    {
        $simpleFormId = isset($_POST['SimpleFormId'])?$_POST['SimpleFormId']:"";
        
        $playerConfig = new PlayerConfig;
        $options = array( 
            'basicInfo'=> new BasicInfo,            
        );        
        $options += self::network( );
        $options += self::proxy(  );
        $options += self::https( $playerConfig, $simpleFormId );
        $options += self::ssl(  );
        $options += self::watchdog(  );
        $options += self::snmp(  );
        
        $this->controller->render( 'network', $options );
    }
}