<?php

require( 'DisplayAction.php' );
require( 'SystemAction.php' );

class SummaryAction extends CAction
{
    public function run()
    {
        $wizard = new Wizard();
        $showWizard = isset( $_GET['wizard']);
		if( $wizard->getWelcome() ){
            if ( !Tools::checkInstallationmode() && !Tools::doShutdown() ){
                // insure that one reboot will be done
                Tools::addReason("initial configuration");                
            }
            $wizard->setActive( false );
            $showWizard = true;
		}
        
		$screenInfo = new ScreenInfo;
        $screenInfo->load();
		
		$diskInfo = new DiskInfo;
        $diskInfo->load();
        
        $playerConfig = new PlayerConfig;        
        $user = User::model()->findByPk( Yii::app()->user->id );       
        if ( $user ){
            $user->password = "";
        }
        if ( isset($_POST['User']) ){            
            $user->attributes = $_POST['User'];
            if ( $user->save() ) {
                $user->updateHttpdSecurity();            
            }
        }

        $options = array( 
            'basicInfo'=> new BasicInfo,
            'screenInfo' => $screenInfo,
            'diskInfo' => $diskInfo,
            'user' => $user,
            'wizard' => $showWizard
        );
        
        $options += DisplayAction::display( $playerConfig, null,  "Display" );
        $options += SystemAction::timeZone( );
        $options += SystemAction::backup( );
        $options += SystemAction::cockpit( );
        $options += SystemAction::playerName( $playerConfig );
        $options += DisplayAction::power();
        $options['data'] = array(
            'time' => date("j M Y G:i:s"),
            'uptime' => $options['basicInfo']->uptimeStr,
            'cpuInfo' => $options['basicInfo']->cpuInfo,
            'storage' => $options['diskInfo']->local,
            'screenSettings' => $options['screenInfo']->settingsStr,
            'screenInfo' => $options['screenInfo']->monitors[0],
            'firmware' => $options['basicInfo']->getFirmwareStr()
        );    
        if ( !$options['screenInfo']->powersaveSupported && $options['serialConfig']->enablePowerSave && !$options['data']['screenInfo']['alert'] ) {
            $options['data']['screenInfo']['alert'] = true;
            $options['data']['screenInfo']['desc'] =  "Display power management is not supported with the currently attached display.";            
        } else {
            $options['data']['screenInfo']['desc'] = "";
        }
        if ( Yii::app()->getRequest()->getPost('wizard') ){
            if ( Tools::doShutdown() || Tools::checkInstallationmode() ){
                Tools::shutdown( true );                
                if ( Yii::app()->user->getState('autolog') ) {
                    Tools::$redirect = "/";
                    Yii::app()->user->setState('autolog', false);
                    Yii::app()->user->logout();
                } else {
                    Tools::$redirect = "/" . Yii::app()->getRequest()->getPathInfo();
                }
            } else {
                Tools::$redirect = "/" . Yii::app()->getRequest()->getPathInfo();
            }
        }
        $this->controller->renderHybrid( 'index', $options );
		
    }
}
