<?php
/* @var $this ConfigController */

$formConfig = $this->beginWidget('SimpleForm', array( 
    'title' => "Log",
    'id' => 'Log',
    'button' => "Apply",
    'action' => array ( 'post' => array() )
) );
    $formConfig->errorSummary( $logConfig );
    
    echo $formConfig->activeCheckBox($logConfig, 'custom', array(), true );   
    echo CHtml::openTag("div", array( 'data-bind' => "visible: custom"), " ");
    echo CHtml::closeTag("div");
$this->endWidget();

$appender = $this->beginWidget('SimpleForm', array( 
    'title' => "Appender",
    'id' => 'Appender',
    'button' => "Update",
    'action' => array ( 'post' => array() )
) );
    $idx=0;
    foreach( $logConfig->appenders as $name => $info ) {
        $entry = $info->appender[$info->type];
        $type = $info->appenderList[$info->type];
        echo CHtml::openTag( "div" );
            echo CHtml::tag("h5", array(), htmlspecialchars($info->name)). "\n";

            echo $appender->activeCheckBox($info, "[$idx]AllLoggers"  ); 
            echo $appender->activeHiddenField($info, "[$idx]name");
            echo $appender->activeHiddenField($info, "[$idx]type");
            echo $appender->activeDropDownList($info, "[$idx]Threshold", $appenderConfig->priorityList  ); 
            echo $appender->activeTextField($info, "[$idx]ConversionPattern" );
            foreach( $entry as $item ) {
                echo $appender->activeTextField($info, "[$idx]$item" );
            }
            $this->widget('DialogButton', array(
                'label' => "Remove",
                'content' => false,
                'script' => '$(this).parent().parent().parent().remove()'
            ) );        
        echo CHtml::closeTag( "div" );
        $idx++;
    }
$this->endWidget();

$newAppender = $this->beginWidget('SimpleForm', array( 
    'title' => "New Appender",
    'id' => 'NewAppender',
    'button' => "New",
    'action' => array ( 'post' => array() )
) );    

    echo $newAppender->activeTextField($appenderConfig, 'name' ); 
    echo $newAppender->activeDropDownList($appenderConfig, 'type',  $appenderConfig->appenderList ); 
    echo $newAppender->activeDropDownList($appenderConfig, 'Threshold', $appenderConfig->priorityList  ); 
    echo $newAppender->activeTextField($appenderConfig, 'ConversionPattern' ); 
    
    echo $newAppender->activeCheckBox($info, "AllLoggers"  );
    
$this->endWidget();


function printLog($loggerNames, $level, $loggerBaseName, $logConfig, $logger, &$idx, $that) {
    
	foreach($loggerNames as $name => $val){
        
        $idx++;
        $row = $that->beginWidget('BsRow', array( 
            'options' => array( 
                "style"=>"padding-top: 2px; padding-bottom: 0px;  border-bottom:solid 1px #ddd" 
        )));
        $row->beginCol( 12-count($logConfig->appenders)-2 );
            $loggerRow = $that->beginWidget('BsRow');

                $loggerName = $loggerBaseName.".".$name;
                if ( isset($logConfig->loggers[$loggerName]) ){
                    $logger_obj = $logConfig->loggers[$loggerName];            
                }else {
                    $logger_obj = new LoggerConfig;
                    $logger_obj->name = $loggerName;
                }
                $loggerRow->addCol( array( 
                    'size' => 12-$level,
                    'offset' => $level,
                    'content'=> CHtml::encode($name). 
                                CHtml::activeHiddenField($logger_obj, "[$idx]name")
                ) );
            $that->endWidget();
        $row->endCol();
        
        
        foreach( $logConfig->appenders as $info ) {
            $row->addCol( array( 
                'size' => 1,
                'options'=> array( 'style' => 'padding-top: 3px;'),
                'content'=> $logger->activeCheckBox($logger_obj, "[$idx]".$info->name  )
            ));
        }
		$row->addCol( array( 
                'size' => 2,
                'content' => $logger->activeDropDownList(
                                $logger_obj, "[$idx]priority", $info->priorityList,
                                array( 'title' => "", 'data-style' => "btn-sm")  
                             ) 
                )
        );
        
        $that->endWidget();
        
        if (is_array($val)){
			printLog($val, $level+1, $loggerName, $logConfig, $logger, $idx, $that);
		}
	}
}
$loggerConfig= new LoggerConfig;
$logger = $this->beginWidget('SimpleForm', array( 
    'title' => "Logger",
    'id' => 'Logger',
    'button' => "Update",
    'action' => array ( 'post' => array() )
) );    
    $idx2 =-1;
    
    echo $logger->activeDropDownList($logConfig, "priority", $logConfig->priorityList );
            
    $row = $this->beginWidget('BsRow');
    $row->addCol( array( 'size' => 12-count($logConfig->appenders)-2, 'content'=>"" ) );
    foreach( $logConfig->appenders as $info ) {
        $row->addCol( array( 
            'size' => 1,
            'content'=> CHtml::encode($info->name)  
        ));
    }
    $row->addCol( array( 
            'size' => 2,
            'content' => ""
    ));
    $this->endWidget();
    $logger->noLabel =  true;
    printLog( $logConfig->loggernames, 0, "spx", $logConfig, $logger, $idx2, $this);
    
$this->endWidget();