<?php
/* @var $this ConfigController */


if ( !isset( $wizard ) )
    $wizard = false;
if ( $wizard ){
    $options = array(
        'nbBox' => null,
        'labelSize' => 12,
        'inputSize' => 12,
        'formClass' => "",
    );
} else {
    $options = array( 
        'title' => "Display",
        'id' => "Display",
        'button' => "Apply",
        'action' => array ( 'post' => array() )
    );
}

$formConfig = $this->beginWidget('SimpleForm', $options );
    $formConfig->errorSummary( $playerConfig );
    $formConfig->errorSummary( $screenSettings );
    
    if ( $wizard ){        
        echo $formConfig->activeHiddenField($screenSettings, "modeSelect", array(), true ) ."\n" ;        
    } else {
        
        $this->renderPartial('display/info', array( 'screenInfo' => $screenInfo ) );
        $modes = array( "Simple" );
        if ( Yii::app()->branding->hasRight('displayAdvanced') ){
            $modes[] = "Advanced";
        }
        if ( Yii::app()->branding->hasRight('displayCustom') ){
            $modes[] = "Custom";
        }
        if ( count($modes) > 1 ) {
            echo $formConfig->activeDropDownList( $screenSettings, "modeSelect", 
                $modes, array( ), true
            );
        } else {
            echo $formConfig->activeHiddenField($screenSettings, "modeSelect", array(), true ) ."\n" ;
        }
    }
    if ( Yii::app()->branding->product == "DiVA" ){
        $wizard = true; // only simplified mode in DiVA
    }
    echo CHtml::openTag("div", array( 'data-bind' => "if: modeSelect() == 0") );
    
        $vals = array();
        $cur = null;
        $arMap = array();
        
                
        foreach ($screenSettings->getPresets( $wizard ) as $id => $values){            
            if ( is_array($values) ){
                $arMap[$id] = $values[3];
                if ( $cur !== null ){
                    $vals[$cur][$id] = CHtml::encode($values[4]) ." ".CHtml::encode($values[5]);
                } else {
                    $vals[$id] = CHtml::encode($values[4]) ." ".CHtml::encode($values[5]);
                }                
            }else{
                $cur = CHtml::encode($values);                
            }
        }
        echo $formConfig->activeDropDownList( $screenSettings, "simpledisplay", 
                                              $vals, array( ), true );
    echo CHtml::closeTag("div") ."\n";
    
    echo CHtml::openTag("div", array( 'data-bind' => "if: modeSelect() == 1") );
        
        if ( count($screenSettings->screenSelect)>0 ) {
            echo $formConfig->activeDropDownList( $screenSettings, "advancedtype", array(
                'builtin' => 'Standard modes',
                'screen' => 'Screen modes',
            ), array(), true );  
            echo CHtml::tag( "div", array(
                    'data-bind' => "if: advancedtype()==='builtin'"
                ),
                $formConfig->activeSelect2($screenSettings, "custom", 
                                           $screenSettings->builtinSelect, array( ), true ) );
            echo CHtml::tag( "div", array(
                    'data-bind' => "if: advancedtype()==='screen'"
                ),
                $formConfig->activeSelect2($screenSettings, "custom", 
                                           $screenSettings->screenSelect, array( ), true ) );
        } else {	
            echo CHtml::activeHiddenField($screenSettings, "advancedtype", array( 
                'value' => 'builtin',
                'data-bind' => "enable: modeSelect() == 1"
            ) ) ."\n" ;
            echo $formConfig->activeSelect2($screenSettings, "custom", 
                                            $screenSettings->builtinSelect, array(), true );
        }
        
        
    echo CHtml::closeTag("div") ."\n";
    
    echo CHtml::openTag("div", array( 'data-bind' => "if: modeSelect() == 2") );
        echo CHtml::activeHiddenField($screenSettings, "advancedtype", array(), true ) ."\n" ;
        echo $formConfig->activeTextField($screenSettings, "custom", array(), true );
    echo CHtml::closeTag("div") ."\n";
    
    echo CHtml::openTag("div", array( 'data-bind' => "if: modeSelect() > 0") );
        echo $formConfig->activeHiddenField( $screenSettings, "simpledisplay", array( 'value'=> "" ) );
        echo $formConfig->activeCheckBox($screenSettings, "underscansupp", array(), true);
    echo CHtml::closeTag("div") ."\n";
    
    echo CHtml::activeHiddenField($screenSettings, "forcear", array( 
        'value' => '1',
         'data-bind' => "if: modeSelect() == 0"
    ) ) ."\n" ;
    if ( Yii::app()->branding->hasRight('displayAR') ){
        echo $formConfig->activeDropDownList( $screenSettings, "screeenar", 
                                              $screenSettings->default_mon_ar, array(), true
        );
    } else {
        echo  $formConfig->activeHiddenField($screenSettings, "screeenar", array( ), true ) ."\n" ;
    }
    echo $formConfig->activeDropDownList( $playerConfig, "orientation", $playerConfig->getOrientationsList($wizard) );

$this->endWidget();

?>
<script type="text/javascript" >
//<![CDATA[
yiiModel.simpledisplay.subscribe( function(newValue) {
    var arMap = <?php echo json_encode($arMap); ?>;    
//    if ( !yiiModel.forcear() ){
        yiiModel.screeenar( arMap[newValue] );        
    //}    
});
//]]></script>
