<?php
/* @var $this ConfigController */

$httpsConfig = $this->beginWidget('SimpleForm', array( 
    'title' => "HTTPS",
    'id' => "HTTPS",
    'button' => "Apply",
    'action' => array ( 'post' => array() )
) );
    $httpsConfig->errorSummary( $sslConfig );
    $headers = array(
        "Name", "Issuer", "Serial Number", ""
    );
    $options = array(
        "data-bind" => "foreach: certificates",
        "sizes" => array( "col-sm-3", "col-sm-5", "col-sm-3", "col-sm-1" )
    );
    $row = array();
    $row[] = CHtml::tag( "span", array(
        "data-bind" => "text: name"
    ), "");
    $row[] = CHtml::tag( "span", array(
        "data-bind" => "text: country?(organization+' ('+country+')'):organization"
    ), "");
    $row[] = CHtml::tag( "span", array(
        "data-bind" => "text: serial"
    ), "");
    $row[] = CHtml::link( CHtml::tag("i", array( "class" => "fa fa-times"), "" ), array( 'certificates/delete' ), array(
        "data-bind" => "visible: uploaded, click: \$parent.doRemoveCertificate",
        "class" => "btn btn-sm btn-warning btn-block"
    ) );
    $this->widget('BsRow', array( 
        'options' => array( 'data-bind' => 'visible: certificates().length > 0', 'class' => 'table-responsive'),
        'content' => $httpsConfig->table( $headers, array( $row ), $options ) 
    ));
    
    $httpsConfig->moreButtons = array( $this->widget('ActionButton', array( 
                            'label' => 'Add Certificates', 
                            'block' => true,
                            'file' => CHtml::activeName( $sslConfig, "uploadedfile" ),
                            'args' =>   "{ ".
                                            "url: '". CHtml::normalizeUrl( array( 'certificates/add' ) ). "', ".    
                                            "done: addCertificate" .
                                        "}"
        ), true ) 
    );
    
    $httpsConfig->errorSummary( $playerConfig );    
    echo $httpsConfig->activeCheckBox($playerConfig, "HTTPSUseDefaultCA");
        
$this->endWidget();

?>
<script type="text/javascript" >
//<![CDATA[
yiiModel.certificates = ko.observableArray( <?php
    echo CJavaScript::encode( $sslConfig->getFileList( ) );
?> );

yiiModel.doRemoveCertificate = function( model, ev ) {
    var item = this;
    var btn = $(ev.currentTarget);
    var opt = {
        url: btn.attr("href"),
        data: { target : item.filename },
        type: 'POST'
    };
    yiiModel.doAjax( yiiModel, ev, opt, function( reponse ) {
        yiiModel.certificates.remove( item );
    });
};
function addCertificate( e, data ) {
    var response = data.result;
    if ( response.success ){
        yiiModel.certificates.push( response.data );        
    }
};

//]]></script>