<?php
/* @var $this ConfigController */

if ( $modem3g->isPINBlocked() ) {
    $this->widget("Gritter", array(
        'title' => "Warning",
        'desc' => 
            "The modem's SIM card is locked because it was initialized with an incorrect PIN too many times. ".
            "The PIN needs to be reset using the PUK: type in the new PIN along with the PUK in the form below and click apply. ".
            "Type the PUK carefully as entering an incorrect PUK too many times in a row will permanently lock the SIM card. ".
            "The PUK is not saved, only the new PIN.\n"
    ));
}

$formConfig = $this->beginWidget('SimpleForm', array( 
    'title' => "IP Configuration",
    'id' => "IP",
    'button' => "Apply",
    'action' => array ( 'post' => array() )
) );
    $data = array(
        array( 'label'=>"IP", 'value' =>  $basicInfo->getIp() ),
        array( 'label'=>"IPv6", 'value' =>  $basicInfo->getIpv6() ),
        array( 'label'=>"Hostname", 'value' =>  $basicInfo->getHostname() .".local" ),
        array( 'label'=>"MAC", 'value' =>  $basicInfo->getMAC() )
    );
    echo BsHtml::alert( BsHtml::ALERT_COLOR_INFO, $this->widget('DataTable', array( 'data' => $data, 'title' => "Current Settings" ), true ) );
    
    $formConfig->errorSummary( $ipConfig );
    $formConfig->errorSummary( $modem3g );
    
    $modes = array(
                "dhcp"=>"DHCP",
                "fixed"=>"Static IP"
            );
    if ( Yii::app()->branding->hasRight('network3G') ){
        $modes['3gsimple'] = "3G Modem (simple)";
        $modes['3gadvanced'] = "3G Modem (advanced)";
    }

    echo $formConfig->items( "Configuration", array( 
            CHtml::dropDownList("combined", "", $modes, array(
                "data-bind"=> "bootstrapSelect: combined",
                "class" => "form-control"
            ))
    ) );
    /*
    echo $formConfig->activeDropDownList( $ipConfig, "netiface", 
            $ipConfig->netifaceSelect, array( ), true
    );     
    */
    echo CHtml::activeHiddenField( $ipConfig, "netiface", array(
                "data-bind"=> "value: netiface",
    ));
    echo CHtml::openTag("div", array( 'data-bind' => "if: netiface() == '".IPConfig::NET_ETHERNET."'") );
        /*
        echo $formConfig->activeCheckBox( $ipConfig, "dhcp", 
                                          array( ), true
        );         
         */
        echo CHtml::activeHiddenField( $ipConfig, "dhcp", array(
                    "data-bind"=> "value: dhcp",
        ));
        $options = array(
            'placeholder' => "xxx.xxx.xxx.xxx"
        );
        echo CHtml::openTag("div", array( 'data-bind' => "ifnot: dhcp") );
            echo $formConfig->activeTextField( $ipConfig, "address", $options );
            echo $formConfig->activeTextField( $ipConfig, "netmask", $options);
            echo $formConfig->activeTextField( $ipConfig, "gateway", $options);
            echo $formConfig->activeTextField( $ipConfig, "nameserver1", $options);
            echo $formConfig->activeTextField( $ipConfig, "nameserver2", $options);
            echo $formConfig->activeTextField( $ipConfig, "nameserver3", $options);
            echo $formConfig->activeTextField( $ipConfig, "domain");
        echo CHtml::closeTag("div");
    echo CHtml::closeTag("div");
    
    
    echo CHtml::openTag("div", array( 'data-bind' => "if: netiface() == '".IPConfig::NET_MODEM."'") );
        /*
        echo $formConfig->activeDropDownList( $modem3g, "simple", 
            array( 1 => 'Simple', 0=> 'Advanced'), array( ), true
        );
        */
        echo CHtml::activeHiddenField( $modem3g, "simple", array(
                    "data-bind"=> "value: simple",
        ));
        foreach ($modem3g->getFormNames() as $fname) {
            $options = array( );
            if ( ! $modem3g->isFieldActive($fname) )
                continue;
            if ( $modem3g->isSimpleOnly($fname) ) {
                echo CHtml::openTag("div", array( 'data-bind' => "if: simple() == '1'") );
            }
            if ( $modem3g->isAdvancedOnly($fname) ) {
                echo CHtml::openTag("div", array( 'data-bind' => "if: simple() == '0'") );
            }
            
            $fhelp = $modem3g->getFieldHelp($fname); 
            if ( $fhelp )
                $options['placeholder'] = html_entity_decode( $fhelp );
            if ($modem3g->isChoiceField($fname)) {
                echo $formConfig->activeDropDownList( $modem3g, $fname, 
                                    $modem3g->getFieldChoices($fname), array(), true);
            } else {
               echo $formConfig->activetextField( $modem3g, $fname, $options );
            }
            
            // do something about the help
            
            if ( $modem3g->isSimpleOnly($fname) || $modem3g->isAdvancedOnly($fname) ) {
                echo CHtml::closeTag("div");
            }
        }
        
    echo CHtml::closeTag("div");
    
$this->endWidget();

$this->activeObservable( $ipConfig, array(
    "netiface", "dhcp"
));
$this->activeObservable( $modem3g, array(
    "simple"
));
?>
<script type="text/javascript" >
//<![CDATA[
yiiModel.combined = ko.computed({
    read: function () {
        if ( this.netiface() === 'ethernet' ){
            if ( yiiModel.dhcp() )
                return "dhcp";
            else
                return "fixed";
        } else{
            if ( this.simple() && this.simple() !== '0' )
                return "3gsimple";
            else
                return "3gadvanced";
        }
    },
    write: function (value) {
        if ( value === "dhcp" ){
            this.netiface( 'ethernet' );
            this.dhcp( 1 );
        } else if ( value === "fixed" ){
            this.netiface( 'ethernet' );
            this.dhcp( 0 );
        } else if ( value === "3gsimple" ){
            this.netiface( 'modem' );
            this.simple( 1 );
        } else {
            this.netiface( 'modem' );
            this.simple( 0 );
        }        
    },
    owner: yiiModel
});
//]]></script>