<?php


$this->registerSpxScript( 'basemodel.js' );
$this->registerSpxScript( 'firmware.js' );


$config = array(
    'bootId' => Tools::getBootID(),
    'urlReboot' => CHtml::normalizeUrl( array("/controlcenter/operation/reboot", 'reboot'=>true, ) ),
    'bootNow' => Tools::checkReboot(),
    'instalMode' => Tools::checkInstallationmode(),
    'pendingChangeList' => Tools::getPendingChangeList(),
    'addMessages' => Tools::getMessages()

); 
$configFirmware = array(
    'urlNetCheck' => CHtml::normalizeUrl(array("/controlcenter/operation/checkNetwork")),
    'urlFirmware' => CHtml::normalizeUrl(array("/controlcenter/firmware/check")),
    'source' => $source,
    'infoTarget' => "#FirmwareInfo"
);
if ( Updater::isUpdateInProgress() ){
    $configFirmware['handle'] = true;
}

echo CHtml::script( $this->localScript )."\n";   

$this->beginWidget('bootstrap.widgets.BsPanel', array(
    'title' => 'Updating firmware'    
));

    echo CHtml::tag( "div", array( "id" => "FirmwareInfo") , "" );
    echo CHtml::tag( "div", array( "id" => "Running", "style" => "text-align: center;"),
            CHtml::tag( "i", array( "class" => "fa fa-circle-o-notch fa-spin fa-4x" ), "" )
        );
    if ( !Yii::app()->user->getIsGuest() ){
        $this->widget('SimpleForm', array( 
            'nbBox' => false,
            'title' => "Logs",
            'hide' => true,
            'desc' => CHtml::tag("pre", array( 'data-bind'=>'foreach: firmwareStatus().logs' ),
                "<!-- ko text: \$data + \"\\n\" --><!-- /ko -->")
        ) );
    }
    //echo CHtml::tag( "div" , array( 'data-bind' => 'text: ko.toJSON(firmwareStatus)' ), " ");

$this->endWidget();
?>
<script type="text/javascript" >
//<![CDATA[
$(function() {
    extendModelExt( yiiModel, [], <?php echo CJavaScript::encode( $config ); ?> );
    extendModelFirmware( yiiModel, <?php echo CJavaScript::encode( $configFirmware ); ?> );

    ko.applyBindings( yiiModel );
    
    yiiModel.firmwareStatus.subscribe( function( newValue ) {    
        if ( newValue.running ){
            $('#Running').show();
            $('#head-nav').hide();
        } else {
            $('#Running').hide();
            $('#head-nav').show();
        }
    });
<?php 
    if ( Yii::app()->user->getIsGuest() ){
        echo "setTimeout( function() { location.reload();},30*1000 );\n$('#head-nav').hide();\n";
    } else if ( isset($configFirmware['handle']) ){
        echo "yiiModel.updateStatus();";
    } else {
        echo "yiiModel.updateStart();";
    }
?>
});
//]]></script>
